Package: GRENITS
Type: Package
Title: Gene Regulatory Network Inference Using Time Series
Version: 1.65.0
Date: 2012-03-15
Author: Edward Morrissey
Maintainer: Edward Morrissey <edward.morrissey@gmail.com>
Description: The package offers four network inference statistical
        models using Dynamic Bayesian Networks and Gibbs Variable
        Selection: a linear interaction model, two linear interaction
        models with added experimental noise (Gaussian and Student
        distributed) for the case where replicates are available and a
        non-linear interaction model.
License: GPL (>= 2)
LazyLoad: yes
Depends: R (>= 2.12.0), Rcpp (>= 0.8.6), RcppArmadillo (>= 0.2.8),
        ggplot2 (>= 0.9.0)
Imports: graphics, grDevices, reshape2, stats, utils
Suggests: network
LinkingTo: Rcpp, RcppArmadillo
biocViews: NetworkInference, GeneRegulation, TimeCourse,
        GraphAndNetwork, GeneExpression, Network, Bayesian
git_url: https://git.bioconductor.org/packages/GRENITS
git_branch: devel
git_last_commit: 82b57b4
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 23:01:08 UTC; biocbuild

useDynLib(GRENITS)
exportPattern("^[[:alpha:]]+")
#importFrom(ggplot2, ggplot.data.frame, aes, facet_grid, geom_tile, ggplot, labs, opts,
#           scale_fill_gradient, scale_x_discrete, scale_y_discrete,
#           theme_blank, theme_text, GeomTile, Geom)
#importClassesFrom(ggplot2, Geom)
#importFrom(proto, proto)
importFrom(graphics, barplot, legend, lines, mtext, par, plot, points,
            polygon,   title)
importFrom(grDevices, dev.off, pdf)
importFrom(reshape2, melt)
importFrom(stats, dbeta, density, dgamma, dnorm)
importFrom(utils, read.table, write.table)

## Build default parameter vectors for "Student Error"
mcmc.defaultParams_student <- function()
{
  params        <- c(150000, 5000, 10, 0.5, 0.5, 2, 0.1, 0.1, 2, 0.01, 3.4, 0.15, 2, 6)
  names(params) <- c( "samples", "burn.in", "thin", "c", "d", "sigma.s", "a", "b", "a_exp", "b_exp", "a_deg", "b_deg", "sigma.mu", "fix.y.iter")
  params
}

## Build default parameter vectors for "Linear Model"
mcmc.defaultParams_Linear <- function()
{
  params        <- c(100000, 10000, 10, 0.5, 0.5, 2, 2, 0.01, 2)
  names(params) <- c( "samples", "burn.in", "thin", "c", "d", "sigma.s", "a", "b", "sigma.mu")
  params
}

## Build default parameter vectors for "Non Linear Model"
mcmc.defaultParams_nonLinear <- function()
{
  params        <- c(100000, 10000, 10, 0.5, 0.5, 10000, 0.25, 13, 2, 0.01, 2, 1.5)
  names(params) <- c( "samples", "burn.in", "thin", "c", "d", "trunc", "tau0",  "M", "a", "b", "sigma.mu", "a_pareto")
  params
}

## Build default parameter vectors for "Gaussian Error"
mcmc.defaultParams_gauss <- function()
{
  params        <- c(150000, 5000, 10, 0.5, 0.5, 2, 0.1, 0.1, 2, 0.01, 2, 6)
  names(params) <- c( "samples", "burn.in", "thin", "c", "d", "sigma.s", "a", "b", "a_exp", "b_exp", "sigma.mu", "fix.y.iter")
  params
}

.getSquareMatIndicesFromFlat <- function(flatIndex, matSize)
{
  colIndex              <- ceiling(flatIndex/matSize)
  rowIndex              <- flatIndex%%matSize
  rowIndex[rowIndex==0] <- matSize
  cbind(rowIndex,colIndex)
}

.makeFixedGammasMat <- function(genes, Regulators.vec, fixMe)
{
  if (is.null(fixMe)){   
    fixMe       <- matrix(NaN, genes, genes)
    diag(fixMe) <- 1
  }

  if (!is.null(Regulators.vec)){
    # Make non regulators index vector
    nonRegs.indx         <- 1:genes
    nonRegs.indx         <- nonRegs.indx[-1*Regulators.vec]
    # Store self interaction element
    diag.aux             <- diag(fixMe)    
    # Fix non regulators regulation elems to off
    fixMe[,nonRegs.indx] <- 0
    # Restore self interaction to initial value
    diag(fixMe)          <- diag.aux
  } 
  fixMe
}

.readLargeFileReturnMean_c <- function(file.name)
{
  aa <- .Call("readLargeFileGetMean", file.name, PACKAGE = "GRENITS")
  aa
}

.readGammaFile_Return_MeanAndNumParents_c <- function(file.name, linksFixed)
{  
  aa <- .Call("readGamma_getMean_numParents", file.name, as.matrix(linksFixed), PACKAGE = "GRENITS")
  aa
}


.readLargeFileReturnMean <- function(Bfile, chain.len)
{
  con_B         <- file(Bfile, "r")
  B.j           <- scan(con_B, nlines  =1, sep=",", quiet = T) #, flush = T)
  sumB          <- B.j
  for(j in 2:chain.len)
  {    
#     B.j <- try(scan(con_B, nlines  =1, sep=",", quiet = T), silent = T)
    B.j  <- scan(con_B, nlines  =1, sep=",", quiet = T)
    sumB <- sumB + B.j
  }
  close(con_B)
  # Return mean
  sumB/chain.len
}


.paramVecType <- function(parameter.vec)
{
  length.priors <- length(parameter.vec)
  if(length.priors == 9)
  {
    param.type <- "Linear_Param"
  }
  # Dodgy work around
  if(names(parameter.vec)[6] == "trunc")
  {
    param.type <- "nonLinear_Param"
  }
  if(length.priors == 14)
  {
    param.type <- "RepsStudent_Param"
  }
  # Dodgy work around
  if((length.priors == 12) && (names(parameter.vec)[6] != "trunc"))
  {
    param.type <- "RepsGauss_Param"
  }
  param.type
}

.remove_trailingSlash <- function(folderName)
{
    len.name <- nchar(folderName)
    lastChar <- substr(folderName, len.name, len.name)
    # Remove last char
    if (lastChar == "/" | lastChar=="\\"){folderName <- substr(folderName, 1, len.name-1)}
    return(folderName)
}

.readFast <- function(file.name)
{
  numElems <- length(scan(file.name, sep =",", nlines=1, quiet = T))
  aa       <- matrix(scan(file.name, sep =",", quiet = T), ncol = numElems, byrow = T)
  if (sum(is.nan(aa)) !=0)
  {
    print(paste("Warning found NANs in ", file.name))
  }
  aa
}

.writeGeneNames <- function(dataMatrix, resultsFolder)
{
  numGenes  <- dim(dataMatrix)[1]
  geneNames <- rownames(dataMatrix)
  ## Check to see if they are numbers or if any names (matrix problem)  
  num.geneNames <- suppressWarnings(as.numeric(geneNames))
  if(!any(is.na(num.geneNames)) | (length(geneNames) != numGenes))
  {
    geneNames <- paste("G", 1:numGenes)
  }
  write.table(geneNames, paste(resultsFolder, "/geneNames.txt", sep=""))
}



## If any links are more than problem.thresh between chains report
.linkConvergenceMessage <- function(link.probs, problem.thresh = 0.2)
{
  link.diff <- abs(link.probs[,1] - link.probs[,2])
  if (sum(link.diff>problem.thresh) != 0)
  {
    sink("CONVERGENCE_WARNING")
    print(paste("There are", sum(link.diff>problem.thresh), "links with a differnce of more than", problem.thresh))
    print("Check ConvergencePlots.pdf and consider a longer run.")
    sink()
    message(paste("There are", sum(link.diff>problem.thresh), "link probabilities that have not fully converged."))
    message("Check ConvergencePlots.pdf and consider a longer run.")
  }
}


## -----------------------------------------------------------------------------------------------
##  Cut off gammas   ------------------------------------------------------------
## -----------------------------------------------------------------------------------------------
.plotCutOffGammas <- function(link.prob.1, chainName="", true.net = NULL, main.text = "", nonTF = 0)
{
  genes     <- sqrt(length(link.prob.1))
  if ( nonTF == 0 | genes == nonTF)
  {
    diag.elem <- diag(matrix(1:length(link.prob.1), genes, genes))
  }else{
    diag.elem <- matrix(1:length(link.prob.1), nrow = nonTF)[,1]
  }
  
  remove.me <- NULL
  ## If large, remove links (<0.01) 
  if(length(link.prob.1)> 1000)
  {	
    remove.me <- which(link.prob.1 < 0.01)
  }
  ## Remove diagonals
#   links <- sort(link.prob.1[-diag.elem], decreasing =T)
  link.noDiag <- link.prob.1[-c(diag.elem, remove.me)]
  new.order   <- order(link.noDiag , decreasing =T)
  links       <- link.noDiag[new.order]
  numLinks    <- length(links)
  col.all     <- rep("black", numLinks)
  pch.all     <- rep(1, numLinks)
  if (length(true.net)!=0)
  {
    true.vec     <- as.vector(true.net)[-diag.elem]
    ordered.true <- true.vec[new.order] != 0
    col.all[ordered.true] <- "red"
    pch.all[ordered.true] <- 4
    
  }
  plot(x = links, y = 1:length(links),
       xlab = "Link probability threshold",ylab = "Number of links above threshold", 
       xlim = c(0,1), col = col.all, pch = pch.all, main = main.text, cex = 2.5 )#, cex.lab = 1.7) 
#, main =paste("Number of links for given threshold", chainName))
  
}


## -----------------------------------------------------------------------------------------------
##  Heatmap using ggplot              ------------------------------------------------------------
## -----------------------------------------------------------------------------------------------
.heatMap.ggplot <- function(prob.mat, size.max = 80)
{
      title.string <- "Link Probability"
      ## If too large, sub select
      if(dim(prob.mat)[1]> size.max)
      {
      	topNumLinks      <- floor(size.max/2)
      	prob.mat.largest <- order(prob.mat, decreasing= T)
      	rowsAndCols      <- as.vector(.getSquareMatIndicesFromFlat(prob.mat.largest[1:topNumLinks], dim(prob.mat)[1]))
      	prob.mat         <- prob.mat[rowsAndCols, rowsAndCols]
      	title.string     <- paste(title.string, "(Selected genes)")
      }
      all.m <- melt(as.matrix(prob.mat))
      (p <- ggplot(all.m, aes(Var2, Var1)) + 
      geom_tile(aes(fill = value),colour = "white") + 
      scale_fill_gradient(low = "white",     high = "steelblue", limits = c(0,1)) +
      theme(axis.ticks = element_blank(), axis.text.x = element_text(angle = 30, hjust = 1)) +
      ggtitle( title.string) +
      labs(x = "Regulator", y = "Regulated") +
      scale_x_discrete(expand = c(0, 0)) +
      scale_y_discrete(expand = c(0, 0)) 
    )
    print(p)
}

##-----------------------------------------------------------------------------------------------
## Calculate and plot distributions on num of parents     ---------------------------------------
## excluding self interactions                            ---------------------------------------
##-----------------------------------------------------------------------------------------------
.plotDistribParents.LargeMat <- function(probMat, numParentsMat, geneNames, numRegs = NULL, max.parents = 4, numHighLinks = 4)
{
  nonTF.net <- T
  if (is.null(numRegs)){
    numRegs   <- length(geneNames)
    nonTF.net <- F
  }
  numNonReg <- length(geneNames)

  numberParents <- dim(numParentsMat)[2] - 1
  ## Reduce numParentsMat to max number of parents if necessary
  if (numRegs - (max.parents+1) > 1)
  {
    max.parentsOrMore               <- rowSums(numParentsMat[,(max.parents+1):numRegs])
    numParentsProbs.final           <- cbind(numParentsMat[,1:max.parents], max.parentsOrMore)
    col.names.aux                   <- c(0:(max.parents-1), paste(">", max.parents-1))
#     colnames(numParentsProbs.final) <- col.names.aux
  }else{
    numParentsProbs.final           <- numParentsMat
    col.names.aux                   <- as.character(c(0:numberParents))
    colnames(numParentsProbs.final) <- as.character(c(0:numberParents))
  }
  rownames(numParentsProbs.final) <- geneNames
  numParentsProbs.final           <- data.frame(rownames(numParentsProbs.final), rep("Same", numNonReg), rep("Posterior Probability # Parents", numNonReg), numParentsProbs.final)
  colnames(numParentsProbs.final) <- c("GeneNames", "Same", "ProbType", col.names.aux )
  
  matHighLinks <- matrix(0, numNonReg, numHighLinks)
  if (!nonTF.net){diag(probMat) <- 0}else{probMat[,1] <- 0}
  
  for(i in 1:numNonReg)
  {
    matHighLinks[i,] <- sort(probMat[i,], T)[1:numHighLinks]
  }

  matHighLinks <- data.frame(geneNames,  rep("Same", numNonReg), rep(paste("Top", numHighLinks, "Regulator Probabilities"), numNonReg), matHighLinks)
  colnames(matHighLinks) <- c("GeneNames", "Same", "ProbType",paste("#", 1:numHighLinks))

  ## Filter out those with prob[0 parents] > 0.6
  remove.these <- which(numParentsProbs.final[,4] > 0.5)
  # Remove only if more than 20 would be left
  if ((numNonReg-length(remove.these) > 20) & (length(remove.these)!=0))
  {
     matHighLinks          <- matHighLinks[-1*remove.these,]
     numParentsProbs.final <- numParentsProbs.final[-1*remove.these,]
  }

  ## How many plots?
  numRowsToPlot  <- dim(matHighLinks)[1]
  max.chunk.size <- 30
  numChunks      <- ceiling(numRowsToPlot/max.chunk.size)
  for (i in 1:numChunks)
  {
    first.elem <- max.chunk.size*(i-1) + 1
    last.elem  <- max.chunk.size*i
    if (i == numChunks){last.elem <- numRowsToPlot}
    numParentsProbs.final_i <- numParentsProbs.final[first.elem:last.elem,]
    matHighLinks_i          <- matHighLinks[first.elem:last.elem,]
    
    all.m <- suppressMessages(melt(list(numParentsProbs.final_i, matHighLinks_i )))
    (p <- ggplot(all.m, aes(variable, GeneNames)) + 
      geom_tile(aes(fill = value),colour = "white") + 
      scale_fill_gradient(low = "white",     high = "steelblue", limits = c(0,1)) +
      theme(axis.ticks = element_blank(), axis.text.x = element_text(angle = 30, hjust = 1)) +
      ggtitle("Network Uncertainty") +
      labs(x = "",y="") +
      scale_x_discrete(expand = c(0, 0)) +
      scale_y_discrete(expand = c(0, 0)) +  
      #facet_grid( Same ~ ProbType, scales = "free")
      facet_wrap( ~ProbType, ncol = 2, scales = "free")
     
    )
    ## Save
    print(p)
  }
}

##-----------------------------------------------------------------------------------------------
## Calculate and plot distributions on num of parents     ---------------------------------------
## excluding self interactions                            ---------------------------------------
##-----------------------------------------------------------------------------------------------
.marginalUncertaintyPlot <- function(gamma.chain, geneNames, numRegs = NULL, max.parents = 4, numHighLinks = 4)
{
  nonTF.net <- T
  if (is.null(numRegs)){
    numRegs   <- length(geneNames)
    nonTF.net <- F
  }
  numNonReg <- length(geneNames)
  lenChain <- dim(gamma.chain)[1]
  ## Make count number of parents matrix 
  numParentsMat <- matrix(0, numNonReg, numRegs)  
  for (i in 1:lenChain)
  {
    net.i <- matrix(gamma.chain[i,], nrow = numNonReg)
    ## Remove self interactions
    if (!nonTF.net){diag(net.i) <- 0}else{net.i[,1] <- 0}
    parents.i   <- rowSums(net.i)
    for (j in 1:numNonReg)
    {
	numParentsMat[j, parents.i[j] + 1] <- numParentsMat[j, parents.i[j] + 1] + 1
    }
  }
  ## Divide by chain length
  numParentsMat <- numParentsMat/lenChain 
#   write.table(numParentsMat, "ProbNumParents_Full")
  probMat <- matrix(colMeans(gamma.chain), ncol = numRegs)
  if(!nonTF.net){numRegs <- NULL}
  .plotDistribParents.LargeMat(probMat, numParentsMat, geneNames, numRegs , max.parents , numHighLinks)
}


## -----------------------------------------------------------------------------------------------
##  Plot distribution and prior lambda --------------------------------------------------
## -----------------------------------------------------------------------------------------------
.plotDistribWithGammaPrior <- function(lambda, prior.a, prior.b, numGenes, main.text ="Prior and posterior lambda", max.x = 500)
{
  all.dens <- matrix(0, numGenes, 512)
  all.x    <- matrix(0, numGenes, 512)
  ## Loop through genes plotting densities
  for (i in 1:numGenes)
  {
    dens.i       <- density(lambda[,i], na.rm=T, from = 0, n = 512)
    all.dens[i,] <- dens.i$y
    all.x[i,]    <- dens.i$x
  } 

  #max.x  <- max(all.x)*1.1
  # max.x  <- 500
  max.y  <- max(all.dens)*1.2
  x.seq  <- seq(from=0, to = max.x, length.out = 10000)
  prior1 <- list(x = x.seq ,
		  y = dgamma(x.seq, shape = prior.a, rate = prior.b))

  ## Plot priors
  plot(x = prior1$x, y = prior1$y, col="red", lty=2, type="l", 
	ylim = c(0,max.y), lwd = 2, main=main.text, xlab = "Degrees of freedom", 
	ylab = "Probability density" )

  ## Loop through genes plotting densities
  for (i in 1:numGenes)
  {
    lines(y = all.dens[i,], x=  all.x[i,], lwd = 0.7)
  } 
  ## Add legend 
  legend("topright", c(paste("prior ", paste(prior.a, prior.b)), "posterior"), col=c("red", "black"), lty=c(2,1)) 
}

##-----------------------------------------------------------------------------------------------
## Pareto  pdf     ------------------------------------------------------------------------
##-----------------------------------------------------------------------------------------------
.dpareto <- function(tau,a, b)
{
  a*b^(-a)*tau^(a-1)
}

.Fpareto <- function(a, b, num.points=10000)
{
  tau.vals <- matrix(seq(from=0, to = b, length.out = num.points),nrow=1)
  #print(tau.vals)
  list(y=apply(tau.vals, 2, .dpareto, a=a, b=b),x=tau.vals)
}

## -----------------------------------------------------------------------------------------------
##  Calculate tau when link on ------------------------------------------------------------
## -----------------------------------------------------------------------------------------------
.tauON <- function(tau, gamma.vals)
{
  tau.on     <- tau*gamma.vals
  tau.on[tau.on ==0 ]<-NA 
  tau.on
}

## -----------------------------------------------------------------------------------------------
##  Plot distribution and prior tau ------------------------------------------------------------
## -----------------------------------------------------------------------------------------------
.plotDistribAndPriorTau.sepSelf <- function(tau1, link.prob.1, prior.param)
{
  ## Prior parameter values
  a_pareto <- prior.param[12]
  truncMe  <- prior.param[ 6]

  ## Separate self interaction elements 
  num.links     <- length(link.prob.1)
  numGenes      <- sqrt(num.links)
  self.interact <- diag(matrix(1:num.links, numGenes, numGenes))
  no.self       <- 1:num.links
  no.self       <- no.self[-self.interact]

  ## Find max value of link prob to use as plotting limits for tau
  non.diag.links  <- link.prob.1[no.self]
  pos.max.nonSelf <- which(non.diag.links == max(non.diag.links))[1]
  i.max           <- no.self[pos.max.nonSelf]

  ### Plot NON self interactions -------------
  dens.kk <- density(tau1[,i.max ], na.rm=T)
  max.x  <- max(dens.kk$x)
  max.y  <- max(dens.kk$y)*1.2
  # prior1 <- gaga(prior.param$a_spline, prior.param$c_spline, prior.param$d_spline,  interval=c(0,max.x))
  prior1 <- .Fpareto(a_pareto, truncMe)
  ## Plot priors
  # plot(x = c(0, truncMe), y = c(1/truncMe,1/truncMe), col="green",lty=2,type="l", xlim=c(0,truncMe),ylim = c(0,max.y),lwd = 2, main="Prior and posterior tau (with prob>0.35) NON-SELF")
  plot(x = prior1$x, y = prior1$y, xlab = "tau", ylab = "Probability Density", col="red",lty=2,type="l", ylim = c(0,max.y),lwd = 2, main="Prior and posterior tau (with prob>0.35)")

  ## Loop through genes plotting densities
  for (i in no.self )
  {
    ## tau1
    if (link.prob.1[i]>0.35)
    {
      dens.i <- density(tau1[,i], na.rm=T, from=0)
      lines(dens.i, lwd = 0.7)
    }
  } 
  # legend("topright", c(paste("prior ", paste(prior.param$a_spline, prior.param$c_spline, prior.param$d_spline)), "posterior"), col=c("green", "black"), lty=c(2,1)) 
  legend("topright", c(paste("prior pareto a =", a_pareto, ", trunc =", truncMe), "posterior"), col=c("red", "black"), lty=c(2,1)) 


  ### Plot SELF interactions if on -----------------
  if (link.prob.1[1]!=0){
      dens.kk <- density(tau1[,1], na.rm=T)
      max.x  <- max(dens.kk$x)
      max.y  <- max(dens.kk$y)*1.5
      # prior1 <- gaga(prior.param$a_spline, prior.param$c_spline, prior.param$d_spline,  interval=c(0,max.x))
      prior1 <- .Fpareto(3*a_pareto, truncMe)

      ## Plot priors
    #   plot(x = c(0, truncMe), y = c(1/truncMe,1/truncMe), col="green",lty=2,type="l", xlim=c(0,truncMe),ylim = c(0,max.y),lwd = 2, main="Prior and posterior tau SELF")
      plot(x = prior1$x, y = prior1$y, xlab = "tau", ylab = "Probability Density", col="red",lty=2,type="l", ylim = c(0,max.y),lwd = 2, main="Prior and posterior tau SELF")

      ## Loop through genes plotting densities
      for (i in self.interact )
      {
	dens.i <- density(tau1[,i], na.rm=T, from=0)
	lines(dens.i, lwd = 0.7)
      } 
      legend("topright", c(paste("prior pareto a = 3x", a_pareto, ", trunc =", truncMe), "posterior"), col=c("red", "black"), lty=c(2,1)) 
  }

}

## -----------------------------------------------------------------------------------------------
##  Reconstruction   -----------------------------------------------------------------------------
## -----------------------------------------------------------------------------------------------
.plotSplinesFunctions <- function(     allfs1, all.fsqr.1,       Full_F_sqr.1, link.probs1, 
				  data.matrix,  GeneNames, mu.mean, plot.thresh = 0.35) 
# tau1, tau2, allfs1, allfs2, link.probs1, link.probs2, plot.thresh, scaled.data, chainNames, GeneNames, op)
{
  sd.f        <- sqrt(all.fsqr.1 - allfs1^2)
  scaled.data <- t(scale(t(data.matrix)))
  time.m      <- dim(scaled.data)[2] -1
  genes       <- dim(scaled.data)[1]
  probs1      <- matrix(link.probs1, genes, genes)
  index.flat  <- matrix(  1:genes^2, genes, genes)
  diag(probs1) <-1 
  for (i in 1:genes)
  {  
    whichParents <- which(probs1[i,]>plot.thresh)
    numPlots     <- length(whichParents)
#     total.row.plot <- ceiling((length(whichParents) + 1) /2)  
    ## Need either 3 or 4 rows
    if (numPlots < 4){plot.rows <- 2}else{plot.rows <- 3}
#     par(mfrow=c(total.row.plot, 4), mar = c(2,2,4,2), oma = c(0.1,0.1,3.5,0.1))
    par(mfrow=c(plot.rows, plot.rows), mar = c(4,4,3.5,0.6), oma = c(1,1,3.5,1))
    ## Place intersection first
    plotMe.indx <- sort(which(probs1[i,]>plot.thresh), T)
    ## Place self interaction first 
    plotMe.indx <- c(i, plotMe.indx[-1*which(plotMe.indx == i)])
    for (j in plotMe.indx)
    {
      tot.index <- genes*(i-1) + j   
      .plot.reconst(probs1[i,j], allfs1[,tot.index], sd.f[,tot.index], scaled.data, i, j, GeneNames, plot.thresh)      
    }
    meanF     <- rowSums(allfs1[, genes*(i-1) + (1:genes)])
    sd.F      <- sqrt(Full_F_sqr.1[,i] - meanF^2)
    ## Add posterior mean intercept
    meanF     <- meanF + mu.mean[i]
    ## 2 sd lines
    upperLine <- meanF + 2*sd.F
    lowerLine <- meanF - 2*sd.F
    ## Plot y lims
    y.lims <- range(scaled.data[i,-(time.m+1)]) + c(-0.18,0.1)
#     x.lims <- range(scaled.data[j,-total.time]) + c(0,0.18) 
#  plotSplinesFunctions(allfs1, all.fsqr.1,       Full_F_sqr.1, link.probs1, Locke1hLoggedNoNoise.data,  rownames(Locke1hLoggedNoNoise.data))

    # Full reconstruction
    plot(y = upperLine, x = 1:time.m,col = "red", 
    lty = 2, lwd = 2, type = "l", ylim = y.lims, main="", 
    xlab = "time", 
    ylab = paste(GeneNames[i],"(t + 1)") )   

    lines(y = lowerLine, x = 1:time.m, col = "red", lty = 2, lwd = 2)   
    polygon(c(1:time.m, rev(1:time.m)), 
	    c(upperLine, rev(lowerLine)), col = "mistyrose", border = NA)
    lines(y = meanF, x = 1:time.m, col = "red", lty = 1, lwd = 2)   
    points(scaled.data[i,-1])

#     title(main.text, cex.main = 1,   font.main= 2, col.main= "blue")
    legend("bottomright", c(paste("mean F(t)",sep=""), "2xsd"), 
	    col=c("red"), bty = "n", lty = c(1,2), lwd = c(2,2.5))
    title("Full reconstruction",  cex.main = 2,   font.main= 3, col.main= 5)
    mtext(paste("Regulators of:", GeneNames[i]), side=3, line=1.5, font=2, cex=2, col='red',  outer=TRUE)

#     plot(scaled.data[i,-1], main = "", xlab = "Time", ylab = GeneNames[i])
#     meanF <- rowSums(allfs1[, genes*(i-1) + (1:genes)])
#     sd.F  <- sqrt(Full_F_sqr.1 - meanF^2)
#     lines(meanF, col="red", lwd = 1.8)
#     par(op)
  }
}


# Plot data and spline function
.plot.reconst <- function(probs1.ij, allfs1.ij, sd.f.ij, scaled.data, i, j, GeneNames, plot.thresh)
{
  total.time <- dim(scaled.data)[2]
  if (i==j)
  {
    main.text <- "Self Interaction"  
    sub.title <- ""
  }else{
    main.text <- paste(GeneNames[j]," regulates", GeneNames[i], "\n (prob = ", round(probs1.ij,1), ")", sep="")
  }

  kk <- order(scaled.data[j,-total.time])
  ## 2 sd lines
  upperLine <- allfs1.ij[kk] + 2*sd.f.ij[kk]
  lowerLine <- allfs1.ij[kk] - 2*sd.f.ij[kk]
  ## Plot y lims
  y.lims <- range(scaled.data[i,-total.time]) + c(-0.18,0.1)
  x.lims <- range(scaled.data[j,-total.time]) + c(0,0.18) 

  plot(y = upperLine, x = t(scaled.data[j,kk]), col = "red", 
  lty = 2, lwd = 2, type = "l", ylim = y.lims, , xlim = x.lims, main="", 
  xlab = paste(GeneNames[j],"(t)"), 
  ylab = paste(GeneNames[i],"(t + 1)") )   

  lines(y = lowerLine, x = t(scaled.data[j,kk]), col = "red", lty = 2, lwd = 2)   
  polygon(c(t(scaled.data[j,kk]), rev(t(scaled.data[j,kk]))), 
	  c(upperLine, rev(lowerLine)), col = "mistyrose", border = NA)
  lines(y = allfs1.ij[kk], x = t(scaled.data[j,kk]), col = "red", lty = 1, lwd = 2)   
  points(y= t(scaled.data[i,-1]), x=t(scaled.data[j,-total.time]))

  title(main.text, cex.main = 1,   font.main= 2, col.main= "blue")
  legend("bottomright", c(paste("mean f(", GeneNames[j],")",sep=""), "2xsd"), 
	  col=c("red"), bty = "n", lty = c(1,2), lwd = c(2,2.5))
}

.analyseLinear <- function(geneNames, output.folder)
{
  chain.names <- c("Chain 1", "Chain 2")
  file.name.1 <- paste(output.folder, "/chain1", sep="")
  file.name.2 <- paste(output.folder, "/chain2", sep="")

  ## Read data
  lambda.mean.1        <- .readLargeFileReturnMean_c(paste(file.name.1, "/Lambda_mcmc", sep=""))
  mu.mean.1            <- .readLargeFileReturnMean_c(paste(file.name.1, "/Mu_mcmc", sep=""))
  ro.mean.1            <- .readLargeFileReturnMean_c(paste(file.name.1, "/Rho_mcmc", sep=""))
#   meanProbs1    <- .readLargeFileReturnMean_c("Gamma_mcmc")
  meancoeff1           <- .readLargeFileReturnMean_c(paste(file.name.1, "/B_mcmc", sep=""))  
  fixedGammaMat        <- as.matrix(read.table(paste(file.name.1, "/FixedGammaFile", sep="")))
  meanProbs_NumParents <- .readGammaFile_Return_MeanAndNumParents_c(paste(file.name.1, "/Gamma_mcmc", sep=""), fixedGammaMat)
  fixedGammaMat        <- as.vector(fixedGammaMat)
  meanProbs1           <- meanProbs_NumParents[[1]]
  numParents           <- meanProbs_NumParents[[2]]

  lambda.mean.2 <- .readLargeFileReturnMean_c(paste(file.name.2, "/Lambda_mcmc", sep=""))
  mu.mean.2     <- .readLargeFileReturnMean_c(paste(file.name.2, "/Mu_mcmc", sep=""))
  ro.mean.2     <- .readLargeFileReturnMean_c(paste(file.name.2, "/Rho_mcmc", sep=""))
  meanProbs2    <- .readLargeFileReturnMean_c(paste(file.name.2, "/Gamma_mcmc", sep=""))
  meancoeff2    <- .readLargeFileReturnMean_c(paste(file.name.2, "/B_mcmc", sep=""))  

  genes <- length(lambda.mean.2)
  pdf(paste(output.folder, "/ConvergencePlots.pdf", sep=""), 9, 12, title = "ConvergencePlots.pdf")
    old.par <- par(no.readonly = TRUE)
    par(mfrow = c(3,2))
    plot(meanProbs1, meanProbs2, xlab = chain.names[1], ylab = chain.names[2], main = "Gammas")
    lines(c(-100,100), c(-100,100), col= "red")

    plot(meancoeff1, meancoeff2, xlab = chain.names[1], ylab = chain.names[2], main = "B") #, col = col.i)
    lines(c(-100,100), c(-100,100), col= "red")

    plot(ro.mean.1, ro.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Rho") #, col = col.i)
    lines(c(-100,100), c(-100,100), col= "red")

    plot(lambda.mean.1, lambda.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Lambda")#, col = col.i)
    lines(c(-100,100000), c(-100,100000), col= "red")

    plot(mu.mean.1, mu.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Mu")#, col = col.i)
    lines(c(-100,1000), c(-100,1000), col= "red")
    par(old.par)
  dev.off()

  ## Use fixed gamma info for gamma
  notfixed.indx                <- !is.finite(fixedGammaMat)
  fullMeanGamma                <- fixedGammaMat
  fullMeanGamma[notfixed.indx] <- meanProbs1
  # make a copy with fixed elements set to zero

  ## Use fixed gamma info for B
  reg.indx             <- which(notfixed.indx | fixedGammaMat == 1)
  fullMeanB            <- fixedGammaMat
  fullMeanB[reg.indx ] <- meancoeff1

#   mean.B             <- matrix(meancoeff1, genes, genes)
  mean.B             <- matrix(fullMeanB, genes, genes)
  rownames(mean.B )  <- colnames(mean.B) <- geneNames  

#   net.prob           <- matrix(meanProbs1, genes, genes)
  net.prob           <- matrix(fullMeanGamma, genes, genes)
  rownames(net.prob) <- colnames(net.prob) <- geneNames  
  diag(net.prob)     <- 0

  probMat_withZeros                 <- net.prob
  probMat_withZeros[!notfixed.indx] <- 0

  pdf(paste(output.folder, "/AnalysisPlots.pdf", sep=""), 9, 9, title = "AnalysisPlots.pdf")
    ## Network Heatmap
    .heatMap.ggplot(net.prob)
    ## Plot links per cutoff
    .plotCutOffGammas(as.vector(net.prob),  main.text = "Number of links included in model vs Threshold used")
    ## Marginal uncertainty plot
    .plotDistribParents.LargeMat(probMat_withZeros, numParents, geneNames)
  dev.off()
  rownames(numParents) <- geneNames
  colnames(numParents) <- paste(0:length(geneNames), "Regulators")
  ## Write to file num parents
  write.table(numParents, paste(output.folder, "/ProbNumParents.txt", sep=""))


  ## Check link marginals have "reasonably" converged 
  .linkConvergenceMessage(cbind(meanProbs1, meanProbs2))

  netLink  <- which(net.prob > -1, T)
  cytoNet  <- data.frame(geneNames[netLink[,2]], geneNames[netLink[,1]], 
			      net.prob[netLink],        mean.B[netLink])
  colnames(cytoNet) <- c("From", "To", "Probability", "Strength")
  write.table(cytoNet, paste(output.folder, "/NetworkProbability_List.txt", sep=""), row.names=F, quote=F, sep="\t")

  ## Output probabilities in matrix format
  write.table(net.prob, paste(output.folder, "/NetworkProbability_Matrix.txt", sep=""))

}

## plot priors
## Analyse mcmc output
plotPriors <- function(parameter.vec)
{
  old.par <- par(no.readonly = TRUE)
  param.type <- .paramVecType(parameter.vec)
  if(param.type == "Linear_Param")
  {
    .plotPriorsLinear(parameter.vec)
  }
  # Dodgy work around
  if(param.type == "nonLinear_Param")
  {
    .plotPriorsNonLinear(parameter.vec)
  }
  if(param.type == "RepsStudent_Param")
  {
    .plotPriorsErrorStudent(parameter.vec)
  }
  # Dodgy work around
  if(param.type == "RepsGauss_Param")
  {
    .plotPriorsErrorGauss(parameter.vec)
  }
  par(old.par)
}

.plotPriorsLinear <- function(parameter.vec)
{
  par(mfrow=c(3,2))
  # Plot sample, burnin and thin
  barplot(parameter.vec[1:3],  main = "Run parameters")
  # Plot rho prior
  x.vec <- 0.001*(0:1000)
  plot(y = dbeta(x.vec, parameter.vec[4], parameter.vec[5]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Rho", ylab = "Probability density", main = "Prior distribution for \nRho")

  # Plot B prior
  x.vec <- seq(-3*parameter.vec[6], 3*parameter.vec[6], length.out = 1000)
  plot(y = dnorm(x.vec, 0, parameter.vec[6]), 
	x = x.vec, type = "l", col = "red",
	xlab = "B", ylab = "Probability density", main = "Prior distribution for \nCoefficients")

  # Plot lambda prior
  sd.aux <- sqrt(parameter.vec[7]/(parameter.vec[8])^2)
  x.vec <- seq(0, 5*sd.aux, length.out = 1000)
  plot(y = dgamma(x.vec, parameter.vec[7], parameter.vec[8]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Lambda", ylab = "Probability density", main = "Prior distribution for \nPrecision")

  # Plot B prior
  x.vec <- seq(-3*parameter.vec[9], 3*parameter.vec[9], length.out = 1000)
  plot(y = dnorm(x.vec, 0, parameter.vec[9]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Mu", ylab = "Probability density", main = "Prior distribution for \nIntercept")
}


.plotPriorsErrorGauss <- function(parameter.vec)
{
  par(mfrow=c(3,2))
  # Plot sample, burnin and thin
  barplot(parameter.vec[c(1:3)],  main = "Run parameters") #, 12
  # Plot rho prior
  x.vec <- 0.001*(0:1000)
  plot(y = dbeta(x.vec, parameter.vec[4], parameter.vec[5]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Rho", ylab = "Probability density", main = "Prior distribution for \nRho")

  # Plot B prior
  x.vec <- seq(-3*parameter.vec[6], 3*parameter.vec[6], length.out = 1000)
  plot(y = dnorm(x.vec, 0, parameter.vec[6]), 
	x = x.vec, type = "l", col = "red",
	xlab = "B", ylab = "Probability density", main = "Prior distribution for \nCoefficients")

  # Plot lambda prior
  sd.aux <- sqrt(parameter.vec[7]/(parameter.vec[8])^2)
  x.vec <- seq(0, 5*sd.aux, length.out = 1000)
  plot(y = dgamma(x.vec, parameter.vec[7], parameter.vec[8]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Lambda", ylab = "Probability density", main = "Prior distribution for \nPrecision")

  # Plot lambda prior
  sd.aux <- sqrt(parameter.vec[9]/(parameter.vec[10])^2)
  x.vec <- seq(0, 5*sd.aux, length.out = 1000)
  plot(y = dgamma(x.vec, parameter.vec[9], parameter.vec[10]), 
	x = x.vec, type = "l", col = "red",
	xlab = "LambdaExp", ylab = "Probability density", main = "Prior distribution for \nPrecision of Data Replicates")

  # Plot mu prior
  x.vec <- seq(-3*parameter.vec[11], 3*parameter.vec[11], length.out = 1000)
  plot(y = dnorm(x.vec, 0, parameter.vec[11]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Mu", ylab = "Probability density", main = "Prior distribution for \nIntercept")
}

.plotPriorsErrorStudent <- function(parameter.vec)
{
  par(mfrow=c(3,3))
  # Plot sample, burnin and thin
  barplot(parameter.vec[c(1:3)],  main = "Run parameters") #, 14
  # Plot rho prior
  x.vec <- 0.001*(0:1000)
  plot(y = dbeta(x.vec, parameter.vec[4], parameter.vec[5]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Rho", ylab = "Probability density", main = "Prior distribution for \nRho")

  # Plot B prior
  x.vec <- seq(-3*parameter.vec[6], 3*parameter.vec[6], length.out = 1000)
  plot(y = dnorm(x.vec, 0, parameter.vec[6]), 
	x = x.vec, type = "l", col = "red",
	xlab = "B", ylab = "Probability density", main = "Prior distribution for \nCoefficients")

  # Plot lambda prior
  sd.aux <- sqrt(parameter.vec[7]/(parameter.vec[8])^2)
  x.vec <- seq(0, 5*sd.aux, length.out = 1000)
  plot(y = dgamma(x.vec, parameter.vec[7], parameter.vec[8]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Lambda", ylab = "Probability density", main = "Prior distribution for \nPrecision")

  # Plot lambda prior
  sd.aux <- sqrt(parameter.vec[9]/(parameter.vec[10])^2)
  x.vec <- seq(0, 5*sd.aux, length.out = 1000)
  plot(y = dgamma(x.vec, parameter.vec[9], parameter.vec[10]), 
	x = x.vec, type = "l", col = "red",
	xlab = "LambdaExp", ylab = "Probability density", main = "Prior distribution for \nPrecision of Data Replicates")

  # Plot lambda prior
  sd.aux <- sqrt(parameter.vec[11]/(parameter.vec[12])^2)
  x.vec <- seq(0, 5*sd.aux, length.out = 1000)
  plot(y = dgamma(x.vec, parameter.vec[11], parameter.vec[12]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Deg Freedom", ylab = "Probability density", 
	main = "Prior distribution for \nDegrees of Freedom")


  # Plot mu prior
  x.vec <- seq(-3*parameter.vec[13], 3*parameter.vec[13], length.out = 1000)
  plot(y = dnorm(x.vec, 0, parameter.vec[13]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Mu", ylab = "Probability density", main = "Prior distribution for \nIntercept")
  

}


.plotPriorsNonLinear <- function(parameter.vec)
{
  par(mfrow=c(3,2))
  # Plot sample, burnin and thin
  barplot(parameter.vec[1:3],  main = "Run parameters")

  # Plot rho prior
  x.vec <- 0.001*(0:1000)
  plot(y = dbeta(x.vec, parameter.vec[4], parameter.vec[5]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Rho", ylab = "Probability density", main = "Prior distribution for \nRho")

  # Plot tau prior
  xy_vals <- .Fpareto(parameter.vec[12], parameter.vec[6], num.points=10000)
  plot(y = xy_vals$y, 
	x = xy_vals$x, type = "l", col = "red",
	xlab = "Tau", ylab = "Probability density", main = "Prior distribution for \nNonLinearity parameter")

  # Plot lambda prior
  sd.aux <- sqrt(parameter.vec[9]/(parameter.vec[10])^2)
  x.vec <- seq(0, 5*sd.aux, length.out = 1000)
  plot(y = dgamma(x.vec, parameter.vec[9], parameter.vec[10]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Lambda", ylab = "Probability density", main = "Prior distribution \nPrecision")

  # Plot Mu prior
  x.vec <- seq(-3*parameter.vec[11], 3*parameter.vec[11], length.out = 1000)
  plot(y = dnorm(x.vec, 0, parameter.vec[9]), 
	x = x.vec, type = "l", col = "red",
	xlab = "Mu", ylab = "Probability density", main = "Prior distribution for \nIntercept")

  # Plot B1 and B2 prior
  sd.aux <- 1/sqrt(parameter.vec[7])
  x.vec <- seq(-3*sd.aux, 3*sd.aux, length.out = 1000)
  plot(y = dnorm(x.vec, 0, sd.aux), 
	x = x.vec, type = "l", col = "red",
	xlab = "B", ylab = "Probability density", main = "Prior distribution for \nTwo Spline Coefficients")

}

## Analyse mcmc output
analyse.output <- function(output.folder, timeSeries = NULL)
{
  output.folder <- .remove_trailingSlash(output.folder)
  runinfo   <- read.table(paste(output.folder, "/runInfo.txt", sep=""), as.is=T)[,1]
  geneNames <- read.table(paste(output.folder, "/geneNames.txt", sep=""), as.is=T)[,1]
  if (runinfo[1] == "LinearNet")
  {
    .analyseLinear(geneNames, output.folder)    
  }
  if (runinfo[1] == "NonLinearNet")
  {
    if(is.null(timeSeries))
    {
      message("For analysis of the NonLinear run, the data set used is needed.")
    }else{
      .analyseNonLinear(geneNames, output.folder, timeSeries)
    }
  }
  if (runinfo[1] == "ReplicatesNet_student")
  {
    .analyseReps_Student(geneNames, output.folder)
  }
  if (runinfo[1] == "ReplicatesNet_gauss")
  {
    .analyseReps_Gauss(geneNames, output.folder)
  }
  message(paste("Analysis finished. Output plots can be found in folder: \"", output.folder, "\"", sep = ""))
}

## Analyse mcmc output
read.chain <- function(output.folder, chainNumber)
{
  runinfo   <- read.table(paste(output.folder, "/runInfo.txt", sep=""), as.is=T)[,1]
  geneNames <- read.table(paste(output.folder, "/geneNames.txt", sep=""), as.is=T)[,1]
  if (runinfo[1] == "LinearNet")
  {
    chainOut <- .read.linear.chain(output.folder, chainNumber, geneNames)
  }
  if (runinfo[1] == "NonLinearNet")
  {
    chainOut <- .read.splines.chain(output.folder, chainNumber, geneNames)
  }
  if (runinfo[1] == "ReplicatesNet_student")
  {
    chainOut <- .read.reps_student.chain(output.folder, chainNumber, geneNames)
  }
  if (runinfo[1] == "ReplicatesNet_gauss")
  {
    chainOut <- .read.reps_gauss.chain(output.folder, chainNumber, geneNames)
  }  
  chainOut
}

## Function to build vector of all-interactions lables 
.lablesGammaChain <- function(geneNames)
{
  fullLabels <- NULL
  for (i in geneNames)
  {
    fullLabels_i <- paste(i, "regs", geneNames, sep ="-")
    fullLabels <- c(fullLabels, fullLabels_i)
  }
  fullLabels 
}


.read.linear.chain <- function(output.folder, chainNumber, geneNames)
{
  all.interactions.Labels <- .lablesGammaChain(geneNames)
  chain.name  <- paste("chain", chainNumber, sep="")
  file.name.1 <- paste(output.folder, "/", chain.name, sep="")
  ## Check if chain exists, if not exit
  chainExists <- .checkChainExists(output.folder, chain.name)
  if(!chainExists){stop("Chain does not exist")}
  ## Read data
  fixedGammaMat  <- as.matrix(read.table(paste(file.name.1, "/FixedGammaFile", sep="")))
  lambda.mcmc.1  <- .readFast(paste(file.name.1, "/Lambda_mcmc", sep=""))
  colnames(lambda.mcmc.1) <- geneNames
  mu.1           <- .readFast(paste(file.name.1, "/Mu_mcmc", sep=""))
  colnames(mu.1) <- geneNames
  ro.1           <- .readFast(paste(file.name.1, "/Rho_mcmc", sep=""))
  gamma.1        <- .readFast(paste(file.name.1, "/Gamma_mcmc", sep="")) 
  notfixed.indx     <- !is.finite(fixedGammaMat)
  colnames(gamma.1) <- all.interactions.Labels[notfixed.indx]
  coeff.1       <- .readFast(paste(file.name.1, "/B_mcmc", sep="")) 
  reg.indx          <- which(notfixed.indx | fixedGammaMat == 1)
  colnames(coeff.1) <- all.interactions.Labels[reg.indx]

  list(lambda = lambda.mcmc.1,    mu =  mu.1,   rho =     ro.1, 
	gamma =       gamma.1, coeff = coeff.1)
}

.read.splines.chain <- function(output.folder, chainNumber, geneNames)
{
  all.interactions.Labels <- .lablesGammaChain(geneNames)
  chain.name  <- paste("chain", chainNumber, sep="")
  file.name.1 <- paste(output.folder, "/", chain.name, sep="")
  ## Check if chain exists, if not exit
  chainExists <- .checkChainExists(output.folder, chain.name)
  if(!chainExists){stop("Chain does not exist")}
  ## Read data
  fixedGammaMat     <- as.matrix(read.table(paste(file.name.1, "/FixedGammaFile", sep="")))
  lambda.mcmc.1     <- .readFast(paste(file.name.1, "/Lambda_mcmc", sep=""))
  colnames(lambda.mcmc.1) <- geneNames
  mu.1              <- .readFast(paste(file.name.1, "/Mu_mcmc", sep=""))
  colnames(mu.1)    <- geneNames
  ro.1              <- .readFast(paste(file.name.1, "/Rho_mcmc", sep=""))
  gamma.1           <- .readFast(paste(file.name.1, "/Gamma_mcmc", sep="")) 
  notfixed.indx     <- !is.finite(fixedGammaMat)
  colnames(gamma.1) <- all.interactions.Labels[notfixed.indx]
  tau.1             <- .readFast(paste(file.name.1, "/Tau_mcmc", sep="")) 
  reg.indx          <- which(notfixed.indx | fixedGammaMat == 1)
  colnames(tau.1)   <- all.interactions.Labels[reg.indx]
  all.f.1           <- read.table(paste(file.name.1, "/all_f", sep=""))  
  all.interactions.Labels.trans <- as.vector(t(matrix(all.interactions.Labels,length(geneNames),length(geneNames))))
  colnames(all.f.1) <- all.interactions.Labels.trans
  all.fsqr.1        <- read.table(paste(file.name.1, "/all_f_sqr", sep=""))      
  colnames(all.fsqr.1) <- all.interactions.Labels.trans
  list(lambda    = lambda.mcmc.1,  mu =  mu.1,   rho =     ro.1, 
	gamma    =       gamma.1, tau = tau.1, all.f =  all.f.1, 
	all.fsqr =    all.fsqr.1)
}

.read.reps_gauss.chain <- function(output.folder, chainNumber, geneNames)
{
  all.interactions.Labels <- .lablesGammaChain(geneNames)
  chain.name  <- paste("chain", chainNumber, sep="")
  file.name.1 <- paste(output.folder, "/", chain.name, sep="")
  ## Check if chain exists, if not exit
  chainExists <- .checkChainExists(output.folder, chain.name)
  if(!chainExists){stop("Chain does not exist")}
  ## Read data
  fixedGammaMat     <- as.matrix(read.table(paste(file.name.1, "/FixedGammaFile", sep="")))
  lambda.mcmc.1     <- .readFast(paste(file.name.1, "/Lambda_mcmc", sep=""))
  colnames(lambda.mcmc.1) <- geneNames
  mu.1              <- .readFast(paste(file.name.1, "/Mu_mcmc", sep=""))
  colnames(mu.1)    <- geneNames
  ro.1              <- .readFast(paste(file.name.1, "/Rho_mcmc", sep=""))
  gamma.1           <- .readFast(paste(file.name.1, "/Gamma_mcmc", sep="")) 
  notfixed.indx     <- !is.finite(fixedGammaMat)
  colnames(gamma.1) <- all.interactions.Labels[notfixed.indx]

  coeff.1           <- .readFast(paste(file.name.1, "/B_mcmc", sep=""))
  reg.indx          <- which(notfixed.indx | fixedGammaMat == 1)
  colnames(coeff.1) <- all.interactions.Labels[reg.indx]
 
  Y.1               <- read.table(paste(file.name.1, "/Y_mean", sep=""))
  rownames(Y.1)     <- geneNames
  lambda.exp.mcmc.1 <- .readFast(paste(file.name.1, "/Lambda_exp_mcmc", sep=""))
  colnames(lambda.exp.mcmc.1) <- geneNames
#   X.1               <- as.vector(as.matrix(read.table(paste(file.name.1, "/DataMean_standarised", sep=""))))
  X.1               <- as.matrix(read.table(paste(file.name.1, "/DataMean_standarised", sep="")))
  rownames(X.1)     <- geneNames
  list(    lambda =     lambda.mcmc.1,     mu =    mu.1, rho = ro.1, 
	    gamma =           gamma.1,  coeff = coeff.1,   Y =  Y.1, 
       lambda.exp = lambda.exp.mcmc.1, X_mean =     X.1)
}


.read.reps_student.chain <- function(output.folder, chainNumber, geneNames)
{
  all.interactions.Labels <- .lablesGammaChain(geneNames)
  chain.name  <- paste("chain", chainNumber, sep="")
  file.name.1 <- paste(output.folder, "/", chain.name, sep="")
  ## Check if chain exists, if not exit
  chainExists <- .checkChainExists(output.folder, chain.name)
  if(!chainExists){stop("Chain does not exist")}
  ## Read data
  fixedGammaMat     <- as.matrix(read.table(paste(file.name.1, "/FixedGammaFile", sep="")))
  lambda.mcmc.1     <- .readFast(paste(file.name.1, "/Lambda_mcmc", sep=""))
  colnames(lambda.mcmc.1) <- geneNames
  mu.1              <- .readFast(paste(file.name.1, "/Mu_mcmc", sep=""))
  colnames(mu.1)    <- geneNames
  ro.1              <- .readFast(paste(file.name.1, "/Rho_mcmc", sep=""))
  gamma.1           <- .readFast(paste(file.name.1, "/Gamma_mcmc", sep="")) 
  notfixed.indx     <- !is.finite(fixedGammaMat)
  colnames(gamma.1) <- all.interactions.Labels[notfixed.indx]
  coeff.1           <- .readFast(paste(file.name.1, "/B_mcmc", sep="")) 
  reg.indx          <- which(notfixed.indx | fixedGammaMat == 1)
  colnames(coeff.1) <- all.interactions.Labels[reg.indx]
  Y.1               <- read.table(paste(file.name.1, "/Y_mean", sep=""))
  rownames(Y.1)     <- geneNames
  lambda.exp.mcmc.1 <- .readFast(paste(file.name.1, "/Lambda_exp_mcmc", sep=""))
  colnames(lambda.exp.mcmc.1) <- geneNames
  X.1               <- as.vector(as.matrix(read.table(paste(file.name.1, "/DataMean_standarised", sep=""))))
  rownames(X.1)     <- geneNames
  deg.1             <- .readFast(paste(file.name.1, "/DegFreedom_mcmc", sep=""))
  colnames(deg.1) <- geneNames
  acceptanceRatio.1 <- read.table(paste(file.name.1, "/acceptanceRatio", sep=""))[,1]
  list(    lambda =     lambda.mcmc.1,     mu =    mu.1,         rho =  ro.1, 
	    gamma =           gamma.1,  coeff = coeff.1,           Y =   Y.1, 
       lambda.exp = lambda.exp.mcmc.1, X_mean =     X.1,  degFreedom = deg.1,
  acceptanceRatio = acceptanceRatio.1)
}


.checkChainExists <- function(output.folder, chain.name)
{
   dir.out    <- dir(output.folder)
   indx.chain <- grep(chain.name, dir.out)   
   return(length(indx.chain) > 0)  
}

.analyseReps_Student <- function(geneNames, output.folder)
{
  chain.names <- c("Chain 1", "Chain 2")
  file.name.1 <- paste(output.folder, "/chain1", sep="")
  file.name.2 <- paste(output.folder, "/chain2", sep="")
  # final.name  <- paste(out.name, "mat_V_C.pdf", sep ="")

  ## Read data
  lambda.mean.1        <- .readLargeFileReturnMean_c(paste(file.name.1, "/Lambda_mcmc", sep=""))
  mu.mean.1            <- .readLargeFileReturnMean_c(paste(file.name.1, "/Mu_mcmc", sep=""))
  ro.mean.1            <- .readLargeFileReturnMean_c(paste(file.name.1, "/Rho_mcmc", sep=""))
  meancoeff1           <- .readLargeFileReturnMean_c(paste(file.name.1, "/B_mcmc", sep=""))  
  fixedGammaMat        <- as.matrix(read.table(paste(file.name.1, "/FixedGammaFile", sep="")))
  meanProbs_NumParents <- .readGammaFile_Return_MeanAndNumParents_c(paste(file.name.1, "/Gamma_mcmc", sep=""), fixedGammaMat)
  fixedGammaMat        <- as.vector(fixedGammaMat)
  meanProbs1           <- meanProbs_NumParents[[1]]
  numParents           <- meanProbs_NumParents[[2]]

  Y.1                  <- read.table(paste(file.name.1, "/Y_mean", sep=""))
  lambda.exp.mean.1    <- .readLargeFileReturnMean_c(paste(file.name.1, "/Lambda_exp_mcmc", sep=""))
  X.1                  <- as.vector(as.matrix(read.table(paste(file.name.1, "/DataMean_standarised", sep=""))))

  deg.mean.1           <- .readLargeFileReturnMean_c(paste(file.name.1, "/DegFreedom_mcmc", sep=""))
  deg.1                <- .readFast(paste(file.name.1, "/DegFreedom_mcmc", sep="")) 
  acceptanceRatio.1    <- read.table(paste(file.name.1, "/acceptanceRatio", sep=""))[,1]


  lambda.mean.2     <- .readLargeFileReturnMean_c(paste(file.name.2, "/Lambda_mcmc", sep=""))
  mu.mean.2         <- .readLargeFileReturnMean_c(paste(file.name.2, "/Mu_mcmc", sep=""))
  ro.mean.2         <- .readLargeFileReturnMean_c(paste(file.name.2, "/Rho_mcmc", sep=""))
  meanProbs2        <- .readLargeFileReturnMean_c(paste(file.name.2, "/Gamma_mcmc", sep=""))
  meancoeff2        <- .readLargeFileReturnMean_c(paste(file.name.2, "/B_mcmc", sep=""))  
  Y.2               <- read.table(paste(file.name.2, "/Y_mean", sep=""))
  lambda.exp.mean.2 <- .readLargeFileReturnMean_c(paste(file.name.2, "/Lambda_exp_mcmc", sep=""))

  deg.mean.2        <- .readLargeFileReturnMean_c(paste(file.name.2, "/DegFreedom_mcmc", sep=""))
  acceptanceRatio.2 <- read.table(paste(file.name.2, "/acceptanceRatio", sep=""))[,1]


  genes <- length(lambda.mean.1)
  pdf(paste(output.folder, "/ConvergencePlots.pdf", sep=""), 9, 9, title = "ConvergencePlots.pdf")
    old.par <- par(no.readonly = TRUE)
    par(mfrow = c(3,3))
    plot(meanProbs1, meanProbs2, xlab = chain.names[1], ylab = chain.names[2], main = "Gammas")
    lines(c(-100,100), c(-100,100), col= "red")

    plot(meancoeff1, meancoeff2, xlab = chain.names[1], ylab = chain.names[2], main = "B") #, col = col.i)
    lines(c(-100,100), c(-100,100), col= "red")

    plot(ro.mean.1, ro.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Rho") #, col = col.i)
    lines(c(-100,100), c(-100,100), col= "red")

    plot(lambda.mean.1, lambda.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Lambda")#, col = col.i)
    lines(c(-100,100000), c(-100,100000), col= "red")

    plot(mu.mean.1, mu.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Mu")#, col = col.i)
    lines(c(-100,1000), c(-100,1000), col= "red")

    plot(lambda.exp.mean.1, lambda.exp.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Lambda Exp")#, col = col.i)
    lines(c(-100,100000), c(-100,100000), col= "red")

    plot(deg.mean.1, deg.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Degrees of Freedom"); #, col = col.i)
    lines(c(-100,100000), c(-100,100000), col= "red");

    plot(as.vector(as.matrix(Y.1)), as.vector(as.matrix(Y.2)), xlab = chain.names[1], ylab = chain.names[2], main = "Y_means")#, col = col.i)
    lines(c(-100,100000), c(-100,100000), col= "red")
  
    names(acceptanceRatio.1) <- geneNames
    barplot(acceptanceRatio.1, main = "Acceptance ratio \nDegrees of freedom (chain1)", ylim = c(0,1))

    par(old.par)
  dev.off()

  ## Use fixed gamma info for gamma
  notfixed.indx                <- !is.finite(fixedGammaMat)
  fullMeanGamma                <- fixedGammaMat
  fullMeanGamma[notfixed.indx] <- meanProbs1
  # make a copy with fixed elements set to zero

  ## Use fixed gamma info for B
  reg.indx             <- which(notfixed.indx | fixedGammaMat == 1)
  fullMeanB            <- fixedGammaMat
  fullMeanB[reg.indx ] <- meancoeff1

#   mean.B             <- matrix(meancoeff1, genes, genes)
  mean.B             <- matrix(fullMeanB, genes, genes)
  rownames(mean.B )  <- colnames(mean.B) <- geneNames  

#   net.prob           <- matrix(meanProbs1, genes, genes)
  net.prob           <- matrix(fullMeanGamma, genes, genes)
  rownames(net.prob) <- colnames(net.prob) <- geneNames  
  diag(net.prob)     <- 0

  probMat_withZeros                 <- net.prob
  probMat_withZeros[!notfixed.indx] <- 0

  ## read priors 
  runinfo   <- read.table(paste(output.folder, "/runInfo.txt", sep=""), as.is=T)[,1]

  pdf(paste(output.folder, "/AnalysisPlots.pdf", sep=""), 9, 9, title = "AnalysisPlots.pdf")
    ## Network Heatmap
    .heatMap.ggplot(net.prob)
    ## Plot links per cutoff
    .plotCutOffGammas(as.vector(net.prob),  main.text = "Number of links included in model vs Threshold used")
    ## Marginal uncertainty plot
    .plotDistribParents.LargeMat(probMat_withZeros, numParents, geneNames)
    ## Plot inferred data vs mean replicates
    plot(as.vector(as.matrix(Y.1)), X.1, xlab = "Mean of Reps", ylab = "Inferred Value", main = "Mean of replicates Data vs Inferred Value of Data")
    lines(c(-100,1000), c(-100,1000), col= "red")
    ## Plot posterior degrees of freedom 
    .plotDistribWithGammaPrior(deg.1, as.numeric(runinfo[12]), as.numeric(runinfo[13]), genes, "Degrees of freedom", max.x = 70)
  dev.off()

  ## Check link marginals have "reasonably" converged 
  .linkConvergenceMessage(cbind(meanProbs1, meanProbs2))

  netLink  <- which(net.prob > -1, T)
  cytoNet  <- data.frame(geneNames[netLink[,2]], 
	      geneNames[netLink[,1]], net.prob[netLink], mean.B[netLink])
  colnames(cytoNet) <- c("From", "To", "Probability", "Strength")
  write.table(cytoNet, paste(output.folder, "/NetworkProbability_List.txt", sep=""), row.names=F, quote=F, sep="\t")

  ## Output probabilities in matrix format
  write.table(net.prob, paste(output.folder, "/NetworkProbability_Matrix.txt", sep=""))

}

NonLinearNet <- function(resultsFolder, timeSeries, ParamVec = NULL, chains = 2, user.seeds = NULL, 
			  Regulators = NULL, fixMe = NULL)
{
  # If no parameters given use default
  if (is.null(ParamVec)){ParamVec <- mcmc.defaultParams_nonLinear()}
  # Check to see if type of ParamVec correct
  param.type <- .paramVecType(ParamVec)
  if(param.type != "nonLinear_Param"){stop(paste("Parameter vector should be of type \"nonLinear_Param\", not \"", param.type, "\"", sep =""))}

  timeSeries <- as.matrix(timeSeries)
  resultsFolder <- .remove_trailingSlash(resultsFolder)    
  message(paste("Created folder", resultsFolder))
  dir.create(resultsFolder)

  # Write parameters to file
  ParamVec.ForFile <- c("NonLinearNet", ParamVec)
  names(ParamVec.ForFile)[1] <- "runType"
  # Write parameters to file
  write.table(ParamVec.ForFile, paste(resultsFolder, "/runInfo.txt", sep=""))
  # Write gene names to file
  .writeGeneNames(timeSeries, resultsFolder)

  # If no fixed values given, fix diag on
  fixMe <- .makeFixedGammasMat(dim(timeSeries)[1], Regulators, fixMe)

  if (!is.null(user.seeds)){chains <- length(user.seeds)}
  for (i in 1:chains)
  {
    if (!is.null(user.seeds)){set.seed(user.seeds[i])}
    resultsFolder.i <- paste(resultsFolder, "/chain", i, "/", sep = "")
    dir.create(resultsFolder.i)
    message(paste("Started MCMC chain", i, " ============= "))
    .Call("callSplines", timeSeries, resultsFolder.i, ParamVec, fixMe, PACKAGE = "GRENITS")
    message(paste("MCMC chain", i, "finished!"))
    write.table(fixMe, paste(resultsFolder.i, "/FixedGammaFile", sep=""), col.names = F, row.names = F)
  }  
}

.analyseNonLinear <- function(geneNames, output.folder, data.matrix)
{
  chain.names <- c("Chain 1", "Chain 2")
  file.name.1 <- paste(output.folder, "/chain1", sep="")
  file.name.2 <- paste(output.folder, "/chain2", sep="")

  ## Read data
  lambda.mean.1        <- .readLargeFileReturnMean_c(paste(file.name.1, "/Lambda_mcmc", sep=""))
  mu.mean.1            <- .readLargeFileReturnMean_c(paste(file.name.1, "/Mu_mcmc", sep=""))
  ro.mean.1            <- .readLargeFileReturnMean_c(paste(file.name.1, "/Rho_mcmc", sep=""))
  tau.mean.1           <- .readLargeFileReturnMean_c(paste(file.name.1, "/Tau_mcmc", sep=""))  
  all.f.1              <- read.table(paste(file.name.1, "/all_f", sep=""))      
  all.fsqr.1           <- read.table(paste(file.name.1, "/all_f_sqr", sep=""))      
  Full_F_sqr.1         <- read.table(paste(file.name.1, "/Full_F_sqr", sep=""))      
  # Fixed gamma files
  fixedGammaMat        <- as.matrix(read.table(paste(file.name.1, "/FixedGammaFile", sep="")))
  meanProbs_NumParents <- .readGammaFile_Return_MeanAndNumParents_c(paste(file.name.1, "/Gamma_mcmc", sep=""), fixedGammaMat)
  fixedGammaMat        <- as.vector(fixedGammaMat)
  meanProbs1           <- meanProbs_NumParents[[1]]
  numParents           <- meanProbs_NumParents[[2]]


  lambda.mean.2        <- .readLargeFileReturnMean_c(paste(file.name.2, "/Lambda_mcmc", sep=""))
  mu.mean.2            <- .readLargeFileReturnMean_c(paste(file.name.2, "/Mu_mcmc", sep=""))
  ro.mean.2            <- .readLargeFileReturnMean_c(paste(file.name.2, "/Rho_mcmc", sep=""))
  tau.mean.2           <- .readLargeFileReturnMean_c(paste(file.name.2, "/Tau_mcmc", sep=""))
  meanProbs2           <- .readLargeFileReturnMean_c(paste(file.name.2, "/Gamma_mcmc", sep=""))
  all.f.2              <- read.table(paste(file.name.2, "/all_f", sep=""))      

  genes <- length(lambda.mean.2)
  pdf(paste(output.folder, "/ConvergencePlots.pdf", sep=""), 9, 12, title = "ConvergencePlots.pdf")
    old.par <- par(no.readonly = TRUE)
    par(mfrow = c(3,2))
    plot(meanProbs1, meanProbs2, xlab = chain.names[1], ylab = chain.names[2], main = "Gammas")
    lines(c(-100,100), c(-100,100), col= "red")

    plot(tau.mean.1, tau.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "tau") #, col = col.i)
    lines(c(-100,100000), c(-100,100000), col= "red")

    plot(ro.mean.1, ro.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Rho") #, col = col.i)
    lines(c(-100,100), c(-100,100), col= "red")

    plot(lambda.mean.1, lambda.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Lambda")#, col = col.i)
    lines(c(-100,100000), c(-100,100000), col= "red")

    plot(mu.mean.1, mu.mean.2, xlab = chain.names[1], ylab = chain.names[2], main = "Mu")#, col = col.i)
    lines(c(-100,1000), c(-100,1000), col= "red")

    plot(as.vector(as.matrix(all.f.1)), as.vector(as.matrix(all.f.2)), xlab = chain.names[1], ylab = chain.names[2], main = "mean f(x_t)")#, col = col.i)
    lines(c(-100,1000), c(-100,1000), col= "red")
    par(old.par)
  dev.off()

#   ## Get value of tau when on
#   tau.on.1 <- .tauON(tau.1, as.matrix(gamma.1))
  ## Use fixed gamma info for gamma
  notfixed.indx                <- !is.finite(fixedGammaMat)
  fullMeanGamma                <- fixedGammaMat
  fullMeanGamma[notfixed.indx] <- meanProbs1

  net.prob           <- matrix(fullMeanGamma, genes, genes)
  rownames(net.prob) <- colnames(net.prob) <- geneNames  
  diag(net.prob)     <- 0

  probMat_withZeros                 <- net.prob
  probMat_withZeros[!notfixed.indx] <- 0

  ## Read run parameters, remove text and make numeric
  parameters.run <- read.table(paste(output.folder, "/runInfo.txt", sep=""), as.is = T)[,1]
  parameters.run <- as.numeric(parameters.run[2:length(parameters.run)])

  pdf(paste(output.folder, "/AnalysisPlots.pdf", sep=""), 9, 9, title = "AnalysisPlots.pdf")
    ## Network Heatmap
    .heatMap.ggplot(net.prob)
    ## Marginal uncertainty plot
    .plotCutOffGammas(as.vector(net.prob),  main.text = "Number of links included in model vs Threshold used")
    ## Plot links per cutoff
    .plotDistribParents.LargeMat(probMat_withZeros, numParents, geneNames)
    ## Plot prior and posterior tau
#     .plotDistribAndPriorTau.sepSelf(tau.on.1, colMeans(gamma.1), parameters.run)
  dev.off()

 ## library(GRENITS);  output.folder <- "ExampleNonLinearNet";   analyse.output(output.folder)

  pdf(paste(output.folder, "/InferredFunctionPlots.pdf", sep=""), 9, 12, title = "InferredFunctionPlots.pdf")
    ## Inferred functions
    .plotSplinesFunctions(all.f.1, all.fsqr.1, Full_F_sqr.1, as.vector(net.prob),  
			  as.matrix(data.matrix), geneNames, mu.mean.1)
  dev.off()

  rownames(numParents) <- geneNames
  colnames(numParents) <- paste(0:length(geneNames), "Regulators")
  ## Write to file num parents
  write.table(numParents, paste(output.folder, "/ProbNumParents.txt", sep=""))

  ## Check link marginals have "reasonably" converged 
  .linkConvergenceMessage(cbind(meanProbs1, meanProbs2))

  netLink  <- which(net.prob > -1, T)
  cytoNet  <- data.frame(geneNames[netLink[,2]], 
	      geneNames[netLink[,1]], net.prob[netLink]) #, mean.B[netLink])
  colnames(cytoNet) <- c("From", "To", "Probability") #, "Strength")
  write.table(cytoNet, paste(output.folder, "/NetworkProbability_List.txt", sep=""), row.names=F, quote=F, sep="\t")

  ## Output probabilities in matrix format
  write.table(net.prob, paste(output.folder, "/NetworkProbability_Matrix.txt", sep=""))
}

\documentclass[a4paper]{article}
% \VignetteIndexEntry{GRENITS}
\title{GRENITS: \\ Gene Regulatory Network Inference \\ Using Time Series}
\author{Edward R. Morrissey\\
Systems Biology Doctoral Training Centre\\
University of Warwick
}
\date{\today}

\begin{document}

\setkeys{Gin}{width=1\textwidth}
@
% Sweave("GRENITS/inst/doc/GRENITS_package.Rnw"); tools::texi2dvi("GRENITS_package.tex", pdf=TRUE)
\maketitle
\section*{Overview}
GRENITS offers four network inference statistical models using Dynamic Bayesian Networks and Gibbs Variable Selection. 
A linear interaction model, two linear interaction models with added experimental noise (Gaussian and Student distributed) and 
a non-linear interaction model (\cite{Morrissey10} and \cite{Morrissey11}). 
The package is intended to be used by both users with a background in Bayesian Inference, as well as casual users. To this end,
prior parameters and MCMC (Markov chain Monte Carlo) parameters have been set by default to values that in our experience are adequate 
for a large range of data sets. As well as this, some basic diagnostic and analysis plots are provided. 

The example contained in this document shows how to run the Linear Network model, as well as how to analyse the output and how to make an explicit network
prediction.

<<results=hide, echo=false>>=
library(GRENITS)
@
\section*{Example: Network Inference For Simulated Data}

\subsection*{Simulated Data}
The data we will use for this example is data generated by an Ordinary Differential Equation (ODE) model of \textit{A. thaliana}'s circadian clock \cite{Locke}. 
The model was deterministically simulated using COPASI \cite{copasi}. The data was subsampled to produce hourly time spacing and the log was taken.
<<results=verbatim, echo=true>>=
data(Athaliana_ODE)
dim(Athaliana_ODE)
@
The data matrix has genes in rows (5) and time points in columns (50) (fig: \ref{fig:LockeData}). 
\begin{figure}[!h]
\centering
<<fig=true, width=8, height=5, results=hide, echo=false>>=
# Load A. thaliana circadian clock ODE generated data
plot.ts( t(Athaliana_ODE), plot.type = "single", col = 1:5,  xlim = c(0,65),
	main = "Circadian Clock Network \n ODE simulated data",
	 xlab = "Time (h)",  ylab = "Expression")
legend("topright", rownames(Athaliana_ODE), lty = 1, col = 1:5)
@MCMC
\caption{\textit{A. thaliana} Circadian Clock. Simulated data from ODE model \label{fig:LockeData}}
\end{figure}

\subsection*{Inference} 
First we run the MCMC function 
<<results=hide, echo = true >>=
output.folder <- paste(tempdir(), "/Example_LinearNet", sep="")
LinearNet(output.folder, Athaliana_ODE)
@
This will run two MCMC chains with the default parameters. For non default parameter values, a parameter vector 
can be provided (See ?mcmc.defaultParams\_Linear). The output folder contains the raw output from the MCMC 
run (chain1 and chain2), gene names (geneNames.txt) and the values of the parameters used (runInfo.txt). 
Next we analyse the output. 
<<results=hide, echo = true >>=
# Analyse raw results, place analysis plots and files in output.folder
analyse.output(output.folder)
@
The results of the analysis are placed in the run folder.
<<results=verbatim, echo = true >>=
dir(output.folder)
@
The Convergence file (ConvergencePlots.pdf) contains plots associated to the adequate convergence of the MCMC. This is crucial for further analysis
as, if convergence has not been reached, the results are not trustworthy. The most important parameters to check are the connection
probabilities (fig \ref{fig:gamma-gamma}). A certain amount of "jitter" is acceptable. If any link has a probability difference 
larger than 0.2 a warning will be issued (both on screen and as a file) and it would be advisable to re-run the MCMC function with a 
larger number of iterations (See ?mcmc.defaultParams\_Linear).

\begin{figure}[!h]
\centering
<<fig = true, width = 7, height = 7, results = hide, echo = false>>=
chain1 <- read.chain(output.folder,1)
chain2 <- read.chain(output.folder,2)
gamma1 <- colMeans(chain1$gamma)
gamma2 <- colMeans(chain2$gamma)
plot(x = gamma1, y = gamma2, xlab = "chain1", ylab = "chain2", 
main = "Convergence plot for link probabilities", xlim = c(0,1), ylim = c(0,1), cex = 1.5, cex.lab = 1.6, cex.main = 1.6)
lines(c(0,1), c(0,1), col = "red")
@
\caption{Convergence plot \label{fig:gamma-gamma}}
\end{figure}
More formal convergence analysis can also be carried out by reading the chains (?read.chain) and using an MCMC convergence package such as "coda".
Although in our experience with the parameters chosen, convergence is not too problematic. Normally monitoring the link probabilities 
(fig \ref{fig:gamma-gamma}) and if necessary running longer runs  is sufficient to achieve convergence.

To predict a network we first load the inferred network probabilities
<<results=verbatim, echo=true>>=
prob.file <- paste(output.folder, "/NetworkProbability_Matrix.txt", sep = "")
prob.mat  <- read.table(prob.file)
print(prob.mat)
@

By applying a threshold (e.g 0.8) on the link probability (not a p-value!), we can make a network prediction

<<results=verbatim, echo=true>>=
inferred.net <- 1*(prob.mat > 0.8)
print(inferred.net)
@
A plot of the inferred network can be seen in fig \ref{fig:graph} (right), whereas fig \ref{fig:graph} (left) shows 
how the link probabilities are distributed. The latter plot (found in the file "AnalysisPlots.pdf") is useful when 
deciding what threshold to use, especially if the links separate into two groups.

\begin{figure}[!h]
\centering
<<fig=true, width=16, height=8, results=hide, echo = false>>=
library(network)
inferred.net <- network(inferred.net)
par(mfrow = c(1,2), cex = 1.76, cex.lab = 1.3, cex.main = 1.4)
# Plot cut off
prob.vec <- sort(as.vector(as.matrix(prob.mat)), T)
# Remove self interaction (last 5 elements)
prob.vec <- prob.vec[4:0 - length(prob.vec)]
plot(x = prob.vec, y = 1:length(prob.vec), xlim = c(0,1), main = "Connections included vs threshold", 
xlab = "Probability threshold", ylab = "Connections included")
lines(c(0.8,0.8), c(0, 30), col = "red", lty = 2, lwd = 2)
# Plot Network
plot(inferred.net, label = network.vertex.names(inferred.net), main = "A. thaliana Inferred Network", 
mode = "circle", vertex.cex=7, arrowhead.cex = 2,vertex.col="green")
@
\caption{Inferred network. Data used is Simulated data from ODE model \label{fig:graph}}
\end{figure}

For information on the sign of the interaction (activating/inhibiting) see NetworkProbability\_List.txt
<<results=verbatim, echo=true>>=
prob.list.file <- paste(output.folder, "/NetworkProbability_List.txt", sep = "")
prob.list      <- read.table(prob.list.file, header = T)
above.08       <- (prob.list[,3] > 0.8)
print(prob.list[above.08,])
@
This file can be used for further analysis using for example cytoscape \cite{cytoscape}.

\begin{thebibliography}{2011}
\bibitem{Morrissey10} Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J.
{\sl On reverse engineering of gene interaction networks using time course data with repeated measurements.}
Bioinformatics 2010.

\bibitem{Morrissey11} Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J.
{\sl Inferring the time-invariant topology of a nonlinear sparse gene regulatory network using fully 
Bayesian spline autoregression}
Biostatistics 2011.

\bibitem{copasi} Hoops, S., Sahle, S., Gauges, R., Lee, C., Pahle, J., Simus, N., Singhal, M., Xu, L., Mendes, P. and Kummer, U.
{\sl COPASI a COmplex PAthway SImulator.}
Bioinformatics 2006.

\bibitem{Locke} Locke, J.C.W., Kozma-Bognar, L., Gould, P.D., Feher, B., Kevei, E., Nagy, F., Turner, M.S., Hall, A. and Millar,  A.J. 
{\sl Experimental validation of a predicted feedback loop in the multi-oscillator clock of Arabidopsis thaliana.} 
Molecular Systems Biology 2006.

\bibitem{cytoscape} Shannon P, Markiel A, Ozier O, Baliga NS, Wang JT, Ramage D, Amin N, Schwikowski B and Ideker T.
{\sl Cytoscape: a software environment for integrated models of biomolecular interaction networks.}
Genome Research 2003.

\end{thebibliography}


\end{document}

\name{ReplicatesNet_gauss}
\alias{ReplicatesNet_gauss}
\title{Dynamic Bayesian Network Inference Using Linear Interactions and Gaussian Experimental Noise}
\description{
Run Bayesian inference of linear interaction network on data with replicates. The replicates are assumed
to follow a Gaussian distribution. The function generates MCMC chains that can later be analysed.
}
\usage{
ReplicatesNet_gauss(     resultsFolder,   timeSeries,           numReps, 
                       ParamVec = NULL,   chains = 2, user.seeds = NULL,
		     Regulators = NULL, fixMe = NULL)
}
\arguments{
\item{resultsFolder}{Name of output folder. The folder will be created and the output of the run 
will be placed there.}
\item{timeSeries}{Data matrix containing gene expression time series. Where genes will be placed in rows 
and time points in columns. Each times series must be placed one after another, so that the first n 
columns correspond to time series replicate one, the next n columns to time series replicate two, etc.
Gene names may be included as row names.}
\item{numReps}{Number of replicate time series included in timeSeries matrix.}
\item{ParamVec}{A parameter vector created using "mcmc.defaultParams_gauss". If none is given, 
default parameters will be used. The vector contains parameters associated to the priors as 
well as MCMC run length. (See mcmc.defaultParams_gauss)}
\item{chains}{Number of MCMC chains to run.}
\item{user.seeds}{An optional vector with seeds to use for MCMC chains.}
\item{Regulators}{An optional vector with the indices of which genes are regulators. If
provided, all non-regulator genes will not be allowed to regulate.}
\item{fixMe}{An optional matrix of size genes x genes, where columns represent regulators and 
rows regulated genes. The matrix informs the model of network connections known to be present/absent.
For each position use either 0 (no regulation, fix off), 1 (known regulatory interaction, fix on) 
or NaN (no information, do not fix).}
}
\details{
The order in which the replicates are placed do not affect the output. In other words swapping timepoint
2 replicate 1 and timepoint 2 replicate 2 makes no difference. 
For the cases where a measurement is not available, an NaN may be used.
}
\value{
For each chain run, a folder (chain1, chain2, ...) will be created and the output of the MCMC run will
be placed there. The files will be B_mcmc (the coeffcients of the linear regression), Gamma_mcmc (the 
indicator variables of Gibbs variable selection), Lambda_mcmc (the precision of each regression),
Mu_mcmc (the intercept of each regression), Rho_mcmc (the network connectivity parameter), 
DataMean_standarised (a times series with the mean of the replicates), Lambda_exp_mcmc (the precision
of the replicate noise) and Y_mean (the mean posterior value of the inferred "true mRNA").
}

\references{
Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2010. On reverse engineering of gene interaction 
networks using time course data with repeated measurements.  Bioinformatics 2010; doi: 10.1093/bioinformatics/btq421
}
\seealso{
\code{\link{mcmc.defaultParams_gauss}}, \code{\link{analyse.output}}.
}
\keyword{ReplicatesNet}
\examples{
  # Synthetic data
  data(Athaliana_ODE_4NoiseReps)
  # Folder where raw runs will be kept and later analysed
  output.folder <- paste(tempdir(), "/Example_ReplicatesNet_Gauss",sep="")
  # Run network inference and place raw results in output.folder
  ReplicatesNet_gauss(output.folder, Athaliana_ODE_4NoiseReps, numReps = 4)
  # Analyse raw results, place analysis plots and files in output.folder
  analyse.output(output.folder)
}

\name{mcmc.defaultParams_Linear}
\alias{mcmc.defaultParams_Linear}
\title{Default Parameters for Linear Model}
\description{
Create parameter vector with default parameters for LinearNet function
}
\usage{
mcmc.defaultParams_Linear()
}
\details{
Use this function to generate a template parameter vector to use non-default parameters for 
the LinearNet model.
}
\value{
Returns a single vector with the following elements (in this order):
\item{(1) samples}{Number of MCMC iterations to run.}
\item{(2) burn.in}{Number of initial iterations to discard as burn in.}
\item{(3) thin}{Subsampling frequency}
\item{(4) c}{Shape parameter 1 for Beta(c,d) prior on rho (connectivity parameter)}
\item{(5) d}{Shape parameter 2 for Beta(c,d) prior on rho (connectivity parameter)}
\item{(6) sigma.s}{Standard deviation parameter for N(0,sigma.s) prior on B (Regression coefficients)}
\item{(7) a}{Shape parameter for Gamma(a,b) prior on lambda (Regression precision)} 
\item{(8) b}{Rate parameter for Gamma(a,b) prior on lambda (Regression precision)} 
\item{(9) sigma.mu}{Standard deviation parameter for N(0,sigma.mu) prior on mu (Regression intercept)}
}

\references{
Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2010. On reverse engineering of gene interaction 
networks using time course data with repeated measurements.  Bioinformatics 2010; doi: 10.1093/bioinformatics/btq421

Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2011 Inferring the time-invariant 
topology of a nonlinear sparse gene regulatory network using fully Bayesian spline autoregression
Biostatistics 2011; doi: 10.1093/biostatistics/kxr009
}

\seealso{
\code{\link{plotPriors}}, \code{\link{LinearNet}}.
}
\keyword{LinearNet}
\examples{
    # Get default parameters
    linearNet.params <- mcmc.defaultParams_Linear()

    # Change run length
    linearNet.params[1] <- 150000

    # Change prior regression precision 
    linearNet.params[7] <- 0.001
    linearNet.params[8] <- 0.001

    # Plot to check changes
    plotPriors(linearNet.params)

    ## Use to run LinearNet ...
}

\name{read.chain}
\alias{read.chain}
\title{Read MCMC Chains}
\description{
Read MCMC chains for further analysis.
}
\usage{
read.chain(output.folder, chainNumber)
}
\details{
Read chains produced by NonLinearNet, LinearNet, ReplicatesNet_student and ReplicatesNet_gauss 
for further analysis.
}
\arguments{
\item{output.folder}{Name of folder (including path) where chains are kept}
\item{chainNumber}{Which of the chains will be read}
}
\value{
Returns a list of vectors/matrices with the value of the variables at each MCMC iteration.   
}

\references{
Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2010. On reverse engineering of gene interaction 
networks using time course data with repeated measurements.  Bioinformatics 2010; doi: 10.1093/bioinformatics/btq421

Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2011 Inferring the time-invariant 
topology of a nonlinear sparse gene regulatory network using fully Bayesian spline autoregression
Biostatistics 2011; doi: 10.1093/biostatistics/kxr009
}

\seealso{
\code{\link{NonLinearNet}}, \code{\link{LinearNet}}, 
	\code{\link{ReplicatesNet_student} }, \code{\link{ReplicatesNet_gauss} }.
}
\keyword{ReadChains}
\examples{
  #############################################
  ## Run inference using one chain
  #############################################
  # Load A. thaliana circadian clock ODE generated data
  data(Athaliana_ODE)
  # Folder where raw runs will be kept and analysed
  output.folder <- paste(tempdir(), "/Example_LinearNet", sep="")
  # Run network inference, place raw results in output.folder
  # Run just one chain for example purpose
  LinearNet(output.folder, Athaliana_ODE, chains = 1)

  ###########################
  ## Read chain 
  ###########################
  chain1 <- read.chain(output.folder, 1)
}

\name{Athaliana_ODE_4NoiseReps}
\alias{Athaliana_ODE_4NoiseReps}
\docType{data}
\title{Gene expression time series generated with ODE model with added noise}
\description{
This data set was generated using a circadian clock regulatory network ODE model after which noise was added.
The data was simulated using COPASI, subsampled to produce hourly data and after this the log was caluclated. 
Further to this, four replicates were produced by adding student noise.
}
\usage{data(Athaliana_ODE_4NoiseReps)}
\format{A matrix containing genes in rows and (1h) time points in columns. The four replicates are appended (columns)}
\references{
Hoops, S., Sahle, S., Gauges, R., Lee, C., Pahle, J., Simus, N., Singhal, M., Xu, L., Mendes, P. and Kummer, U.
(2006) COPASI a COmplex PAthway SImulator. Bioinformatics, 22, 3067-3074.


Locke, J.C.W., Kozma-Bognar, L., Gould, P.D., Feher, B., Kevei, E., Nagy, F., Turner, M.S., Hall, A. and Millar,  A.J. (2006) 
Experimental validation of a predicted feedback loop in the multi-oscillator clock of Arabidopsis thaliana. Molecular Systems Biology
}
\keyword{datasets}

\name{mcmc.defaultParams_nonLinear}
\alias{mcmc.defaultParams_nonLinear}
\title{Default Parameters for non-Linear Model}
\description{
Create parameter vector with default parameters for NonLinearNet function
}
\usage{
mcmc.defaultParams_nonLinear()
}
\details{
Use this function to generate a template parameter vector to use non-default parameters for 
the NonLinearNet model.
}
\value{
Returns a single vector with the following elements (in this order):
\item{(1) samples}{Number of MCMC iterations to run.}
\item{(2) burn.in}{Number of initial iterations to discard as burn in.}
\item{(3) thin}{Subsampling frequency}
\item{(4) c}{Shape parameter 1 for Beta(c,d) prior on rho (connectivity parameter)}
\item{(5) d}{Shape parameter 2 for Beta(c,d) prior on rho (connectivity parameter)}
\item{(6) trunc}{Truncation parameter for InvertedPareto prior on tau (smoothness parameter)}
\item{(7) tau0}{Precision parameter for N(0, tau0^(-0.5)) prior on B (first two coefficients)}
\item{(8) M}{Numer of knots used for each spline function}
\item{(9) a}{Shape parameter for Gamma(a,b) prior on lambda (Regression precision)} 
\item{(10) b}{Rate parameter for Gamma(a,b) prior on lambda (Regression precision)} 
\item{(11) sigma.mu}{Standard deviation parameter for N(0,sigma.mu) prior on mu (Regression intercept)}
\item{(12) a_pareto}{Pareto parameter for InvertedPareto prior on tau (smoothness parameter)}
}

\references{
Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2011 Inferring the time-invariant 
topology of a nonlinear sparse gene regulatory network using fully Bayesian spline autoregression
Biostatistics 2011; doi: 10.1093/biostatistics/kxr009
}

\seealso{
\code{\link{plotPriors}}, \code{\link{NonLinearNet}}.
}
\keyword{NonLinearNet}
\examples{
    # Get default parameters
    nonLinearNet.params <- mcmc.defaultParams_nonLinear()

    # Change run length
    nonLinearNet.params[1] <- 150000

    # Change prior on smoothness parameter
    nonLinearNet.params[6] <- 30000 # Change truncation 
    nonLinearNet.params[12] <- 3 # Concentrate more mass close to linear region

    # Plot to check changes
    plotPriors(nonLinearNet.params)

    ## Use to run LinearNet ...
}

\name{LinearNet}
\alias{LinearNet}
\title{Dynamic Bayesian Network Inference Using Linear Interactions}
\description{
Run Bayesian inference of linear interaction network. The function generates MCMC chains that can later be 
analysed.
}
\usage{
LinearNet( resultsFolder,        timeSeries,   ParamVec = NULL, 
              chains = 2, user.seeds = NULL, Regulators = NULL, 
	    fixMe = NULL)
}
\arguments{
\item{resultsFolder}{Name of output folder. The folder will be created and the output of the run 
will be placed there.}
\item{timeSeries}{Data matrix containing gene expression time series. Where genes will be placed in rows 
and time points in columns. Gene names may be included as row names.}
\item{ParamVec}{A parameter vector created using "mcmc.defaultParams_Linear". If none is given, 
default parameters will be used. The vector contains parameters associated to the priors as well as MCMC
run length. (See mcmc.defaultParams_Linear)}
\item{chains}{Number of MCMC chains to run.}
\item{user.seeds}{An optional vector with seeds to use for MCMC chains.}
\item{Regulators}{An optional vector with the indices of which genes are regulators. If
provided, all non-regulator genes will not be allowed to regulate.}
\item{fixMe}{An optional matrix of size genes x genes, where columns represent regulators and 
rows regulated genes. The matrix informs the model of network connections known to be present/absent.
For each position use either 0 (no regulation, fix off), 1 (known regulatory interaction, fix on) 
or NaN (no information, do not fix).}
}
\value{
For each chain run, a folder (chain1, chain2, ...) will be created and the output of the MCMC run will
be placed there. The files will be B_mcmc (the coeffcients of the linear regression), Gamma_mcmc (the 
indicator variables of Gibbs variable selection), Lambda_mcmc (the precision of each regression),
Mu_mcmc (the intercept of each regression) and Rho_mcmc (the network connectivity parameter). 
}

\references{
Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2010. On reverse engineering of gene interaction 
networks using time course data with repeated measurements.  Bioinformatics 2010; doi: 10.1093/bioinformatics/btq421

Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2011 Inferring the time-invariant 
topology of a nonlinear sparse gene regulatory network using fully Bayesian spline autoregression
Biostatistics 2011; doi: 10.1093/biostatistics/kxr009
}
\seealso{
\code{\link{mcmc.defaultParams_Linear}, \link{analyse.output}}.
}
\keyword{LinearNet}
\examples{
  # Load A. thaliana circadian clock ODE generated data
  data(Athaliana_ODE)
  # Folder where raw runs will be kept and analysed
  output.folder <- paste(tempdir(), "/Example_LinearNet",sep="")
  # Run network inference, place raw results in output.folder
  LinearNet(output.folder, Athaliana_ODE)
  # Analyse raw results, place analysis plots and files in output.folder
  analyse.output(output.folder)
}

\name{NonLinearNet}
\alias{NonLinearNet}
\title{Dynamic Bayesian Network Inference Using Non-Linear Interactions}
\description{
Run Bayesian inference of non-linear interaction network. Non linear interactions are modelled using 
Penalised Splines. The function generates MCMC chains that can later be analysed.
}
\usage{
NonLinearNet( resultsFolder,        timeSeries,   ParamVec = NULL, 
		 chains = 2, user.seeds = NULL, Regulators = NULL,      
	       fixMe = NULL) 
}
\arguments{
\item{resultsFolder}{Name of output folder. The folder will be created and the output of the run will be placed there.}
\item{timeSeries}{Data matrix containing gene expression time series. Where genes will be placed in rows 
and time points in columns. Gene names may be included as row names.}
\item{ParamVec}{A parameter vector created using "mcmc.defaultParams_nonLinear". If none is given, 
default parameters will be used. The vector contains parameters associated to the priors as well as MCMC
run length. (See mcmc.defaultParams_nonLinear)}
\item{chains}{Number of MCMC chains to run.}
\item{user.seeds}{An optional vector with seeds to use for MCMC chains.}
\item{Regulators}{An optional vector with the indices of which genes are regulators. If
provided, all non-regulator genes will not be allowed to regulate.}
\item{fixMe}{An optional matrix of size genes x genes, where columns represent regulators and 
rows regulated genes. The matrix informs the model of network connections known to be present/absent.
For each position use either 0 (no regulation, fix off), 1 (known regulatory interaction, fix on) 
or NaN (no information, do not fix).}
}

\value{
For each chain run, a folder (chain1, chain2, ...) will be created and the output of the MCMC run will
be placed there. The files will be Gamma_mcmc (the indicator variables of Gibbs variable selection), 
Lambda_mcmc (the precision of each regression), Mu_mcmc (the intercept of each regression), 
Rho_mcmc (the network connectivity parameter), Tau_mcmc (the "smoothness parameter"), all_f (posterior mean
of all functions), all_f_sqr (posterior mean of the square of all functions) and Full_F_sqr (posterior 
mean of the square of the sum of all functions, for each regression). 
For the files all_f and all_f_sqr functions are placed in column-wise order. The file is filled by 
placing all interactions for each regression one after another.
}

\references{
Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2011 Inferring the time-invariant 
topology of a nonlinear sparse gene regulatory network using fully Bayesian spline autoregression
Biostatistics 2011; doi: 10.1093/biostatistics/kxr009
}
\seealso{
\code{\link{mcmc.defaultParams_nonLinear}, \link{analyse.output}}.
}
\keyword{NonLinearNet}
\examples{
  # Synthetic data
  data(Athaliana_ODE)
  # Reduced data set to 3 genes 20 TP for faster run
  Athaliana_ODE.reduced <- Athaliana_ODE[c(1,3,5),1:20]
  # Folder where raw runs will be kept and later analysed
  output.folder <- paste(tempdir(), "/ExampleNonLinearNet", sep = "")
  # Run network inference and place raw results in output.folder
  NonLinearNet(output.folder , Athaliana_ODE.reduced)
  # Analyse raw results, place analysis plots and files in output.folder
  analyse.output(output.folder, Athaliana_ODE.reduced)
}

\name{Athaliana_ODE}
\alias{Athaliana_ODE}
\docType{data}
\title{Gene expression time series generated with ODE model}
\description{
This data set was generated using a circadian clock regulatory network ODE model. The data was simulated using COPASI, subsampled to produce 
hourly data and after this the log was calculated.
}
\usage{data(Athaliana_ODE)}
\format{A matrix containing genes in rows and (1h) time points in columns.}
\references{
Hoops, S., Sahle, S., Gauges, R., Lee, C., Pahle, J., Simus, N., Singhal, M., Xu, L., Mendes, P. and Kummer, U.
(2006) COPASI a COmplex PAthway SImulator. Bioinformatics, 22, 3067-3074.


Locke, J.C.W., Kozma-Bognar, L., Gould, P.D., Feher, B., Kevei, E., Nagy, F., Turner, M.S., Hall, A. and Millar,  A.J. (2006) 
Experimental validation of a predicted feedback loop in the multi-oscillator clock of Arabidopsis thaliana. Molecular Systems Biology
}
\keyword{datasets}

\name{analyse.output}
\alias{analyse.output}
\title{Analysis Plots}
\description{
Analyse output from network inference functions. Basic convergence and analysis plots.
}
\usage{
analyse.output(output.folder, timeSeries = NULL)
}
\details{
Read first two chains run and plot some basic convergence plots (ConvergencePlots.pdf), analysis
plots (AnalysisPlots.pdf), as well as inferred network probabilities in two formats 
(NetworkProbability_List.txt and NetworkProbability_Matrix.txt).
}
\arguments{
\item{output.folder}{Name of folder (including path) where chains are kept}
\item{timeSeries}{Only used by NonLinearModel analysis. Data matrix containing gene expression 
time series. Where genes will be placed in rows and time points in columns.}
}
\value{
The output of the analysis will be four files (five if nonLinearNet). The contents of the two plot files change
depending on the network inference function used. 
\item{ConvergencePlots.pdf}{Basic convergence plots. The posterior means of each variable are compared.}
\item{AnalysisPlots.pdf}{Heatmap plot of network link probabilities as well as marginal network uncertainty
plot. A plot of the number of links predicted by the model for a given probability threshold. For 
ReplicatesNet_student, the posterior distribution of the degrees of freedom
are also plotted. For NonLinearNet, the posterior of the smoothness parameter is plotted.}
\item{NetworkProbability_List.txt}{Posterior probabilities for each network connection in list format, 
including posterior interaction strength for linear models. Can be imported with network analysis software 
such as cytoscape.}
\item{NetworkProbability_Matrix.txt}{Posterior probabilities for each network connection in matrix format.}
\item{ProbNumParents.txt}{Posterior probabilities for number of regulators for each gene.}
\item{InferredFunctionPlots.pdf}{(Only for nonLinearNet) Posterior distribution of predicted functions. 
Data values are plotted as circles.}
}

\references{
Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2010. On reverse engineering of gene interaction 
networks using time course data with repeated measurements.  Bioinformatics 2010; doi: 10.1093/bioinformatics/btq421

Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2011 Inferring the time-invariant 
topology of a nonlinear sparse gene regulatory network using fully Bayesian spline autoregression
Biostatistics 2011; doi: 10.1093/biostatistics/kxr009
}

\seealso{
\code{\link{NonLinearNet}}, \code{\link{LinearNet}}, 
	\code{\link{ReplicatesNet_student} }, \code{\link{ReplicatesNet_gauss}}.
}
\keyword{AnalyseOutput}
\examples{
  # Load A. thaliana circadian clock ODE generated data
  data(Athaliana_ODE)
  # Folder where raw runs will be kept and analysed
  output.folder <- paste(tempdir(), "/Example_LinearNet",sep="")
  # Run network inference, place raw results in output.folder
  LinearNet(output.folder, Athaliana_ODE)
  # Analyse raw results, place analysis plots and files in output.folder
  analyse.output(output.folder)
}

\name{mcmc.defaultParams_gauss}
\alias{mcmc.defaultParams_gauss}
\title{Default Parameters for Linear Model with Gaussian distributed replicates}
\description{
Create parameter vector with default parameters for ReplicatesNet_gauss function
}
\usage{
mcmc.defaultParams_gauss()
}
\details{
Use this function to generate a template parameter vector to use non-default parameters for 
the ReplicatesNet_gauss model.
}
\value{
Returns a single vector with the following elements (in this order):
\item{(1) samples}{Number of MCMC iterations to run}
\item{(2) burn.in}{Number of initial iterations to discard as burn in}
\item{(3) thin}{Subsampling frequency}
\item{(4) c}{Shape parameter 1 for Beta(c,d) prior on rho (connectivity parameter)}
\item{(5) d}{Shape parameter 2 for Beta(c,d) prior on rho (connectivity parameter)}
\item{(6) sigma.s}{Standard deviation parameter for N(0,sigma.s) prior on B (Regression coefficients)}
\item{(7) a}{Shape parameter for Gamma(a,b) prior on lambda (Regression precision)} 
\item{(8) b}{Rate parameter for Gamma(a,b) prior on lambda (Regression precision)} 
\item{(9) a_exp}{Shape parameter for Gamma(a_exp,b_exp) prior on tau (Replicates precision)} 
\item{(10) b_exp}{Rate parameter for Gamma(a_exp,b_exp) prior on tau (Replicates precision)} 
\item{(11) sigma.mu}{Standard deviation parameter for N(0,sigma.mu) prior on mu (Regression intercept)}
\item{(12) fix.y.iter}{Number of iterations for which sampled data Y is fixed}
}

\references{
Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2010. On reverse engineering of gene interaction 
networks using time course data with repeated measurements.  Bioinformatics 2010; doi: 10.1093/bioinformatics/btq421
}

\seealso{
\code{\link{plotPriors}}, \code{\link{ReplicatesNet_gauss}}.
}
\keyword{ReplicatesNet_gauss}
\examples{
    # Get default parameters
    linearNet_Gauss.params <- mcmc.defaultParams_gauss()

    # Change run length
    linearNet_Gauss.params[1] <- 200000

    # Change prior regression precision 
    linearNet_Gauss.params[7] <- 0.001
    linearNet_Gauss.params[8] <- 0.001

    # Plot to visualise changes
    plotPriors(linearNet_Gauss.params)

    ## Use to run ReplicatesNet_gauss ...
}

\name{plotPriors}
\alias{plotPriors}
\title{Plot prior using parameter vector}
\description{
Plot appropriate priors using parameters from vector
}
\usage{
plotPriors(parameter.vec)
}
\details{
This function takes the parameter vector that will be used for network inference function and
plots the priors associated with the parameters given.
}
\arguments{
\item{parameter.vec}{MCMC parameter vector of the type generated by e.g. mcmc.defaultParams_Linear}
}

\references{
Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2010. On reverse engineering of gene interaction 
networks using time course data with repeated measurements.  Bioinformatics 2010; doi: 10.1093/bioinformatics/btq421

Morrissey, E.R., Juarez, M.A., Denby, K.J. and Burroughs, N.J. 2011 Inferring the time-invariant 
topology of a nonlinear sparse gene regulatory network using fully Bayesian spline autoregression
Biostatistics 2011; doi: 10.1093/biostatistics/kxr009
}

\seealso{
\code{\link{mcmc.defaultParams_gauss}}, \code{\link{mcmc.defaultParams_Linear}}, 
	\code{\link{mcmc.defaultParams_nonLinear} }, \code{\link{mcmc.defaultParams_student} }.
}
\keyword{PlotPriors}
\examples{
    # Get default parameters
    nonLinearNet.params <- mcmc.defaultParams_nonLinear()

    # Change run length
    nonLinearNet.params[1] <- 150000

    # Change prior on smoothness parameter
    nonLinearNet.params[6] <- 30000 # Change truncation 
    nonLinearNet.params[12] <- 3 # Concentrate more mass close to linear region

    # Plot to check changes
    plotPriors(nonLinearNet.params)
}
